//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Mainly designed and written by Andr Slabber. No Rights Reserved...  Parts by others...
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  File:         FilesDlg.h
//  Module:       Diary
//  Author:       Andr Slabber
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  Declaration of Class FilesDlg.
//
//////////////////////////////////////////////////////////////////////////////////////////////
#ifndef FILESDLG_H_INCLUDED
#define FILESDLG_H_INCLUDED

class SDiaryDlg;

// SFilesDlg dialog

//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Class SFilesDlg
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  the SFilesDlg handles the buttons and listbox shown on the Files dialog. 
//                Because of the simplicity of this dialog, it has not been made resizeable. 
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Date		Name                  Comments
//	20080921	Andr Slabber         Created
//
//////////////////////////////////////////////////////////////////////////////////////////////
class SFilesDlg : public CDialog
{
	DECLARE_DYNAMIC(SFilesDlg)

public:
	SFilesDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~SFilesDlg();

    virtual BOOL OnInitDialog(void);
	int CountFiles();

// Dialog Data
	enum { IDD = IDD_FILES_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

    int   m_nFilterLoad;

	DECLARE_MESSAGE_MAP()

private:
	SDiaryDlg *ivDiaryDlg;
    char mDirName[20];

   // stuff to correctly reposition if offscreen
   bool ivWindowCentered;
   int  ivTop;
   int  ivLeft;

public:
    void SavePosition(void);
    void AddFileToBox(CString theName);
	void FillListbox();
	afx_msg void OnBnClickedStore();
	afx_msg void OnBnClickedRetrieve();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedDeleteFile();
	afx_msg void OnBnClickedOpen();
};

#endif // FILESDLG_H_INCLUDED