//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Mainly designed and written by Andr Slabber. No Rights Reserved...  Parts by others...
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  File:         RecodeDlg.h
//  Module:       Diary
//  Author:       Andr Slabber
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  Declaration of Class RecodeDlg.
//
//////////////////////////////////////////////////////////////////////////////////////////////

#ifndef RECODEDLG_H_INCLUDED
#define RECODEDLG_H_INCLUDED

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "diary.h"

//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Class SRecodeDlg
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  this file declares the class SRecodeDlg, that is implemented in
//                recodedlg.cpp. It allows for password change in the Diary application.
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Date		Name                  Comments
//	20080921	Andr Slabber         Created
//
//////////////////////////////////////////////////////////////////////////////////////////////
class SRecodeDlg : public CDialog
{
// Construction
public:
   SRecodeDlg(CWnd* pParent = NULL);   // standard constructor

   void RecodeDataFile(CString pFileName, CString pOldCryptKey, CString pNewCryptKey);

// Dialog Data
   //{{AFX_DATA(SRecodeDlg)
   enum { IDD = IDD_RECODE };
   CStatic   ivRecodeStatus;
   CEdit   ivNewCryptKeyRepeat;
   CEdit   ivNewCryptKey;
   //}}AFX_DATA


// Overrides
   // ClassWizard generated virtual function overrides
   //{{AFX_VIRTUAL(SRecodeDlg)
protected:
   virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
   //}}AFX_VIRTUAL

// Implementation
protected:

   // Generated message map functions
   //{{AFX_MSG(SRecodeDlg)
   virtual void OnOK();
   //}}AFX_MSG
   DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif
