//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Mainly designed and written by Andr Slabber. No Rights Reserved...  Parts by others...
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  File:         SLabelDlg.cpp
//  Module:       Diary
//  Author:       Andr Slabber
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  Implementation of Class SLabelDlg.
//
//////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "diary.h"
#include "diarydlg.h"
#include "toolkit.h"
#include "SLabelDlg.h"
#include "monitors.h"
#include "multimonitor.h"
#include "monitordc.h"
#include "todolist.h"

// SLabelDlg dialog

IMPLEMENT_DYNAMIC(SLabelDlg, CDialog)
SLabelDlg::SLabelDlg(CWnd* pParent /*=NULL*/)
	: CDialog(SLabelDlg::IDD, pParent),
	  ivShortcut1(0),
	  ivShortcut2(0),
	  ivShortcut3(0),
	  ivShortcut4(0),
	  ivShortcut5(0),
	  ivShortcut6(0),
	  ivShortcut7(0),
	  ivShortcut8(0),
	  ivShortcut9(0),
	  ivShortcut10(0),
	  ivShortcut11(0),
	  ivShortcut12(0),
	  ivShortcut13(0),
	  ivShortcut14(0),
	  ivShortcut15(0),
	  ivShortcut16(0),
	  ivShortcut17(0),
	  ivShortcut18(0),
	  ivTodoList0(0),
	  ivTodoList1(0),
	  ivTodoList2(0),
	  ivTodoList3(0),
	  ivTodoList4(0),
	  ivTodoList5(0),
	  ivTodoList6(0),
	  ivTodoList7(0)
{
	ivDiaryDlg = (SDiaryDlg *)pParent;
}

SLabelDlg::~SLabelDlg()
{
	if (ivShortcut1) delete ivShortcut1;
	if (ivShortcut2) delete ivShortcut2;
	if (ivShortcut3) delete ivShortcut3;
	if (ivShortcut4) delete ivShortcut4;
	if (ivShortcut5) delete ivShortcut5;
	if (ivShortcut6) delete ivShortcut6;
	if (ivShortcut7) delete ivShortcut7;
	if (ivShortcut8) delete ivShortcut8;
	if (ivShortcut9) delete ivShortcut9;
	if (ivShortcut10) delete ivShortcut10;
	if (ivShortcut11) delete ivShortcut11;
	if (ivShortcut12) delete ivShortcut12;
	if (ivShortcut13) delete ivShortcut13;
	if (ivShortcut14) delete ivShortcut14;
	if (ivShortcut15) delete ivShortcut15;
	if (ivShortcut16) delete ivShortcut16;
	if (ivShortcut17) delete ivShortcut17;
	if (ivShortcut18) delete ivShortcut18;

	if (ivTodoList0) delete ivTodoList0;
	if (ivTodoList1) delete ivTodoList1;
	if (ivTodoList2) delete ivTodoList2;
	if (ivTodoList3) delete ivTodoList3;
	if (ivTodoList4) delete ivTodoList4;
	if (ivTodoList5) delete ivTodoList5;
	if (ivTodoList6) delete ivTodoList6;
	if (ivTodoList7) delete ivTodoList7;
}

void SLabelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(SLabelDlg, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_EN_KILLFOCUS(IDC_EDIT_LBL1, OnEnKillfocusEditLbl1)
	ON_BN_CLICKED(ID_CLEARALL, OnBnClickedClearall)
	ON_EN_CHANGE(IDC_EDIT_TODO1, &SLabelDlg::OnEnChangeEditTodo1)
	ON_EN_CHANGE(IDC_EDIT_TODO2, &SLabelDlg::OnEnChangeEditTodo2)
	ON_EN_CHANGE(IDC_EDIT_TODO3, &SLabelDlg::OnEnChangeEditTodo3)
	ON_EN_CHANGE(IDC_EDIT_TODO4, &SLabelDlg::OnEnChangeEditTodo4)
	ON_EN_CHANGE(IDC_EDIT_TODO5, &SLabelDlg::OnEnChangeEditTodo5)
	ON_EN_CHANGE(IDC_EDIT_TODO6, &SLabelDlg::OnEnChangeEditTodo6)
	ON_EN_CHANGE(IDC_EDIT_TODO7, &SLabelDlg::OnEnChangeEditTodo7)
END_MESSAGE_MAP()

BOOL SLabelDlg::OnInitDialog(void)
{
   BOOL lRetCode = CDialog::OnInitDialog();

   TK_LOG0("Read the position settings and restore them");
   SSetting *lSettingTop    = this->ivDiaryDlg
                                 ->GetSettings()->GetSetting(SET_LABEL_TOP);
   SSetting *lSettingLeft   = this->ivDiaryDlg
                                 ->GetSettings()->GetSetting(SET_LABEL_LEFT);

   if (lSettingTop  != NULL &&
       lSettingLeft != NULL)
   {
      TK_LOG0("Position settings found, positioning window");

      int lTop  = lSettingTop->GetValueAsNumber();
      int lLeft = lSettingLeft->GetValueAsNumber();

	  // make sure it will be on-screen, but keep the original position in config
	  this->SetWindowPos(0, lLeft, lTop, 0, 0, SWP_NOSIZE);
	  if (CMonitors::IsOnScreen( this ) == false)
	  {
		  CMonitor thePrimary = CMonitors::GetPrimaryMonitor();
		  thePrimary.CenterWindowToMonitor(this, true);
		  ivWindowCentered = true;
          WINDOWPLACEMENT lWinPlace;
          this->GetWindowPlacement(&lWinPlace);
          ivTop = lWinPlace.rcNormalPosition.top;
          ivLeft = lWinPlace.rcNormalPosition.left;
	  }
   }

	ivShortcut1->Couple(IDC_EDIT_LBL1, IDC_LBL_CHECK1, IDC_EDIT_WORDS1);
	ivShortcut2->Couple(IDC_EDIT_LBL2, IDC_LBL_CHECK2, IDC_EDIT_WORDS2);
	ivShortcut3->Couple(IDC_EDIT_LBL3, IDC_LBL_CHECK3, IDC_EDIT_WORDS3);
	ivShortcut4->Couple(IDC_EDIT_LBL4, IDC_LBL_CHECK4, IDC_EDIT_WORDS4);
	ivShortcut5->Couple(IDC_EDIT_LBL5, IDC_LBL_CHECK5, IDC_EDIT_WORDS5);
	ivShortcut6->Couple(IDC_EDIT_LBL6, IDC_LBL_CHECK6, IDC_EDIT_WORDS6);
	ivShortcut7->Couple(IDC_EDIT_LBL7, IDC_LBL_CHECK7, IDC_EDIT_WORDS7);
	ivShortcut8->Couple(IDC_EDIT_LBL8, IDC_LBL_CHECK8, IDC_EDIT_WORDS8);
	ivShortcut9->Couple(IDC_EDIT_LBL9, IDC_LBL_CHECK9, IDC_EDIT_WORDS9);
	ivShortcut10->Couple(IDC_EDIT_LBL10, IDC_LBL_CHECK10, IDC_EDIT_WORDS10);
	ivShortcut11->Couple(IDC_EDIT_LBL11, IDC_LBL_CHECK11, IDC_EDIT_WORDS11);
	ivShortcut12->Couple(IDC_EDIT_LBL12, IDC_LBL_CHECK12, IDC_EDIT_WORDS12);
	ivShortcut13->Couple(IDC_EDIT_LBL13, IDC_LBL_CHECK13, IDC_EDIT_WORDS13);
	ivShortcut14->Couple(IDC_EDIT_LBL14, IDC_LBL_CHECK14, IDC_EDIT_WORDS14);
	ivShortcut15->Couple(IDC_EDIT_LBL15, IDC_LBL_CHECK15, IDC_EDIT_WORDS15);
	ivShortcut16->Couple(IDC_EDIT_LBL16, IDC_LBL_CHECK16, IDC_EDIT_WORDS16);
	ivShortcut17->Couple(IDC_EDIT_LBL17, IDC_LBL_CHECK17, IDC_EDIT_WORDS17);
	ivShortcut18->Couple(IDC_EDIT_LBL18, IDC_LBL_CHECK18, IDC_EDIT_WORDS18);

    // couple in todolists
    ivTodoList1->Couple(IDC_EDIT_TODO1);
    ivTodoList2->Couple(IDC_EDIT_TODO2);
    ivTodoList3->Couple(IDC_EDIT_TODO3);
    ivTodoList4->Couple(IDC_EDIT_TODO4);
    ivTodoList5->Couple(IDC_EDIT_TODO5);
    ivTodoList6->Couple(IDC_EDIT_TODO6);
    ivTodoList7->Couple(IDC_EDIT_TODO7);

    ivTodoList1->SettingsToDialog();
    ivTodoList2->SettingsToDialog();
    ivTodoList3->SettingsToDialog();
    ivTodoList4->SettingsToDialog();
    ivTodoList5->SettingsToDialog();
    ivTodoList6->SettingsToDialog();
    ivTodoList7->SettingsToDialog();

	ivShortcut1->SettingsToDialog();
	ivShortcut2->SettingsToDialog();
	ivShortcut3->SettingsToDialog();
	ivShortcut4->SettingsToDialog();
	ivShortcut5->SettingsToDialog();
	ivShortcut6->SettingsToDialog();
	ivShortcut7->SettingsToDialog();
	ivShortcut8->SettingsToDialog();
	ivShortcut9->SettingsToDialog();
	ivShortcut10->SettingsToDialog();
	ivShortcut11->SettingsToDialog();
	ivShortcut12->SettingsToDialog();
	ivShortcut13->SettingsToDialog();
	ivShortcut14->SettingsToDialog();
	ivShortcut15->SettingsToDialog();
	ivShortcut16->SettingsToDialog();
	ivShortcut17->SettingsToDialog();
	ivShortcut18->SettingsToDialog();

    char  *lTitle = new char[MAX_STRING];
    char  *lCurDir = new char[MAX_STRING];
    GetCurrentDirectory(MAX_STRING, lCurDir);
    sprintf_s(lTitle, MAX_STRING - 1,  
              "%s - Configuration", 
              lCurDir);
    TK_LOG1("Set Window title to %s", lTitle);
    SetWindowText(lTitle);

	delete [] lTitle;
	delete [] lCurDir;
	return lRetCode;
}

void SLabelDlg::SavePosition(void)
{
   TK_LOG0("Save window position to settings.dat");
   WINDOWPLACEMENT lWinPlace;
   this->GetWindowPlacement(&lWinPlace);

   // cancel save if window centered, and not moved yet...
   if (ivWindowCentered == true &&
	   (ivTop == lWinPlace.rcNormalPosition.top ||
	    ivLeft == lWinPlace.rcNormalPosition.left))
   {
	   return;
   }

   // ok, we save so set the flag to off
   ivWindowCentered = false;
   ivTop = -1;
   ivLeft = -1;

   TK_LOG0("Get the Top position value");
   char *lTop = new char[MAX_STRING];
   _itoa_s(lWinPlace.rcNormalPosition.top, lTop, MAX_STRING - 1, 10);
   SSetting *lTopSSetting = new SSetting(SET_LABEL_TOP, lTop);
   this->ivDiaryDlg->GetSettings()->AddSetting(lTopSSetting);
   delete [] lTop;
 
   TK_LOG0("Get the Left position value");
   char *lLeft = new char[MAX_STRING];
   _itoa_s(lWinPlace.rcNormalPosition.left, lLeft, MAX_STRING - 1, 10);
   SSetting *lLeftSSetting = new SSetting(SET_LABEL_LEFT, lLeft);
   this->ivDiaryDlg->GetSettings()->AddSetting(lLeftSSetting);
   delete [] lLeft;

   TK_LOG0("Make sure the settings are flushed to disk");
   this->ivDiaryDlg->GetSettings()->WriteFile();
}

void SLabelDlg::OnBnClickedOk()
{
	this->SavePosition();

	ivShortcut1->DialogToSettings(false);
	ivShortcut2->DialogToSettings(false);
	ivShortcut3->DialogToSettings(false);
	ivShortcut4->DialogToSettings(false);
	ivShortcut5->DialogToSettings(false);
	ivShortcut6->DialogToSettings(false);
	ivShortcut7->DialogToSettings(false);
	ivShortcut8->DialogToSettings(false);
	ivShortcut9->DialogToSettings(false);
	ivShortcut10->DialogToSettings(false);
	ivShortcut11->DialogToSettings(false);
	ivShortcut12->DialogToSettings(false);
	ivShortcut13->DialogToSettings(false);
	ivShortcut14->DialogToSettings(false);
	ivShortcut15->DialogToSettings(false);
	ivShortcut16->DialogToSettings(false);
	ivShortcut17->DialogToSettings(false);
	ivShortcut18->DialogToSettings(false);

	ivTodoList1->DialogToSettings(false);
	ivTodoList2->DialogToSettings(false);
	ivTodoList3->DialogToSettings(false);
	ivTodoList4->DialogToSettings(false);
	ivTodoList5->DialogToSettings(false);
	ivTodoList6->DialogToSettings(false);
	ivTodoList7->DialogToSettings(true);

	OnOK();
}

void SLabelDlg::OnBnClickedCancel()
{
	this->SavePosition();

	ivShortcut1->SettingsToDialog();
	ivShortcut2->SettingsToDialog();
	ivShortcut3->SettingsToDialog();
	ivShortcut4->SettingsToDialog();
	ivShortcut5->SettingsToDialog();
	ivShortcut6->SettingsToDialog();
	ivShortcut7->SettingsToDialog();
	ivShortcut8->SettingsToDialog();
	ivShortcut9->SettingsToDialog();
	ivShortcut10->SettingsToDialog();
	ivShortcut11->SettingsToDialog();
	ivShortcut12->SettingsToDialog();
	ivShortcut13->SettingsToDialog();
	ivShortcut14->SettingsToDialog();
	ivShortcut15->SettingsToDialog();
	ivShortcut16->SettingsToDialog();
	ivShortcut17->SettingsToDialog();
	ivShortcut18->SettingsToDialog();

	OnCancel();
}

SShortcut *SLabelDlg::GetLabel(int theNumber)
{
	switch (theNumber)
	{
	case 1:		return ivShortcut1;
	case 2:		return ivShortcut2;
	case 3:		return ivShortcut3;
	case 4:		return ivShortcut4;
	case 5:		return ivShortcut5;
	case 6:		return ivShortcut6;
	case 7:		return ivShortcut7;
	case 8:		return ivShortcut8;
	case 9:		return ivShortcut9;
	case 10:	return ivShortcut10;
	case 11:	return ivShortcut11;
	case 12:	return ivShortcut12;
	case 13:	return ivShortcut13;
	case 14:	return ivShortcut14;
	case 15:	return ivShortcut15;
	case 16:	return ivShortcut16;
	case 17:	return ivShortcut17;
	case 18:	return ivShortcut18;
	}

	return 0;
}

void SLabelDlg::OnEnKillfocusEditLbl1()
{
	ivShortcut1->ReadFromDialog();
	if (ivShortcut1->GetLabelText().GetLength() > 10)
	{
		MessageBox("Label is too long to show on button", 
			       "Warning", 
				   MB_OK);
		this->GetDlgItem(IDC_LBL1)->SetWindowText("");
		this->GetDlgItem(IDC_LBL1)->SetFocus();
	}
}

void SLabelDlg::SetDiaryDlg(SDiaryDlg *theDiaryDlg)
{
	if (ivShortcut1 == 0) ivShortcut1 = new SShortcut(ivDiaryDlg, this, 1);
	if (ivShortcut2 == 0) ivShortcut2 = new SShortcut(ivDiaryDlg, this, 2);
	if (ivShortcut3 == 0) ivShortcut3 = new SShortcut(ivDiaryDlg, this, 3);
	if (ivShortcut4 == 0) ivShortcut4 = new SShortcut(ivDiaryDlg, this, 4);
	if (ivShortcut5 == 0) ivShortcut5 = new SShortcut(ivDiaryDlg, this, 5);
	if (ivShortcut6 == 0) ivShortcut6 = new SShortcut(ivDiaryDlg, this, 6);
	if (ivShortcut7 == 0) ivShortcut7 = new SShortcut(ivDiaryDlg, this, 7);
	if (ivShortcut8 == 0) ivShortcut8 = new SShortcut(ivDiaryDlg, this, 8);
	if (ivShortcut9 == 0) ivShortcut9 = new SShortcut(ivDiaryDlg, this, 9);
	if (ivShortcut10 == 0) ivShortcut10 = new SShortcut(ivDiaryDlg, this, 10);
	if (ivShortcut11 == 0) ivShortcut11 = new SShortcut(ivDiaryDlg, this, 11);
	if (ivShortcut12 == 0) ivShortcut12 = new SShortcut(ivDiaryDlg, this, 12);
	if (ivShortcut13 == 0) ivShortcut13 = new SShortcut(ivDiaryDlg, this, 13);
	if (ivShortcut14 == 0) ivShortcut14 = new SShortcut(ivDiaryDlg, this, 14);
	if (ivShortcut15 == 0) ivShortcut15 = new SShortcut(ivDiaryDlg, this, 15);
	if (ivShortcut16 == 0) ivShortcut16 = new SShortcut(ivDiaryDlg, this, 16);
	if (ivShortcut17 == 0) ivShortcut17 = new SShortcut(ivDiaryDlg, this, 17);
	if (ivShortcut18 == 0) ivShortcut18 = new SShortcut(ivDiaryDlg, this, 18);

	ivShortcut1->ReadFromSettings();
	ivShortcut2->ReadFromSettings();
	ivShortcut3->ReadFromSettings();
	ivShortcut4->ReadFromSettings();
	ivShortcut5->ReadFromSettings();
	ivShortcut6->ReadFromSettings();
	ivShortcut7->ReadFromSettings();
	ivShortcut8->ReadFromSettings();
	ivShortcut9->ReadFromSettings();
	ivShortcut10->ReadFromSettings();
	ivShortcut11->ReadFromSettings();
	ivShortcut12->ReadFromSettings();
	ivShortcut13->ReadFromSettings();
	ivShortcut14->ReadFromSettings();
	ivShortcut15->ReadFromSettings();
	ivShortcut16->ReadFromSettings();
	ivShortcut17->ReadFromSettings();
	ivShortcut18->ReadFromSettings();

	ivShortcut1->Revert();
	ivShortcut2->Revert();
	ivShortcut3->Revert();
	ivShortcut4->Revert();
	ivShortcut5->Revert();
	ivShortcut6->Revert();
	ivShortcut7->Revert();
	ivShortcut8->Revert();
	ivShortcut9->Revert();
	ivShortcut10->Revert();
	ivShortcut11->Revert();
	ivShortcut12->Revert();
	ivShortcut13->Revert();
	ivShortcut14->Revert();
	ivShortcut15->Revert();
	ivShortcut16->Revert();
	ivShortcut17->Revert();
	ivShortcut18->Revert();

	if (ivTodoList0 == 0) ivTodoList0 = new STodoList(0, ivDiaryDlg, this);
	if (ivTodoList1 == 0) ivTodoList1 = new STodoList(1, ivDiaryDlg, this);
	if (ivTodoList2 == 0) ivTodoList2 = new STodoList(2, ivDiaryDlg, this);
	if (ivTodoList3 == 0) ivTodoList3 = new STodoList(3, ivDiaryDlg, this);
	if (ivTodoList4 == 0) ivTodoList4 = new STodoList(4, ivDiaryDlg, this);
	if (ivTodoList5 == 0) ivTodoList5 = new STodoList(5, ivDiaryDlg, this);
	if (ivTodoList6 == 0) ivTodoList6 = new STodoList(6, ivDiaryDlg, this);
	if (ivTodoList7 == 0) ivTodoList7 = new STodoList(7, ivDiaryDlg, this);

	ivTodoList0->ReadFromSettings();
	ivTodoList1->ReadFromSettings();
	ivTodoList2->ReadFromSettings();
	ivTodoList3->ReadFromSettings();
	ivTodoList4->ReadFromSettings();
	ivTodoList5->ReadFromSettings();
	ivTodoList6->ReadFromSettings();
	ivTodoList7->ReadFromSettings();

	ivTodoList0->Revert();
	ivTodoList1->Revert();
	ivTodoList2->Revert();
	ivTodoList3->Revert();
	ivTodoList4->Revert();
	ivTodoList5->Revert();
	ivTodoList6->Revert();
	ivTodoList7->Revert();
}

void SLabelDlg::OnBnClickedClearall()
{
   CString lMsg = "Do you really want to\nclear all label settings?";
   if (MessageBox(lMsg, "Clear Settings", MB_YESNO) == IDYES)
   {
       TK_LOG0("Clear Settings Confirmed");

		ivShortcut1->Clear();
		ivShortcut2->Clear();
		ivShortcut3->Clear();
		ivShortcut4->Clear();
		ivShortcut5->Clear();
		ivShortcut6->Clear();
		ivShortcut7->Clear();
		ivShortcut8->Clear();
		ivShortcut9->Clear();
		ivShortcut10->Clear();
		ivShortcut11->Clear();
		ivShortcut12->Clear();
		ivShortcut13->Clear();
		ivShortcut14->Clear();
		ivShortcut15->Clear();
		ivShortcut16->Clear();
		ivShortcut17->Clear();
		ivShortcut18->Clear();
   }
}

void SLabelDlg::OnEnChangeEditTodo1()
{
}

void SLabelDlg::OnEnChangeEditTodo2()
{
}

void SLabelDlg::OnEnChangeEditTodo3()
{
}

void SLabelDlg::OnEnChangeEditTodo4()
{
}

void SLabelDlg::OnEnChangeEditTodo5()
{
}


void SLabelDlg::OnEnChangeEditTodo6()
{
}

void SLabelDlg::OnEnChangeEditTodo7()
{
}
