//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Mainly designed and written by Andr Slabber. No Rights Reserved...  Parts by others...
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  File:         SLabelDlg.h
//  Module:       Diary
//  Author:       Andr Slabber
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  Declaration of Class SLabelDlg.
//
//////////////////////////////////////////////////////////////////////////////////////////////
#ifndef LABELDLG_H_INCLUDED
#define LABELDLG_H_INCLUDED

#include "diary.h"
#include "SShortcut.h"

class STodoList;
class SDiaryDlg;

//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Class SLabelDlg
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  SLabelDlg handles the various controls in the settings dialog. This is non-
//                resizeable, because it does not need to be. 
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Date		Name                  Comments
//	20080921	Andr Slabber         Created
//
//////////////////////////////////////////////////////////////////////////////////////////////
class SLabelDlg : public CDialog
{
	DECLARE_DYNAMIC(SLabelDlg)

public:
	SLabelDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~SLabelDlg();

    void SavePosition(void);
	void SetDiaryDlg(SDiaryDlg *theDiaryDlg);
	SShortcut *GetLabel(int theNumber);

// Dialog Data
	enum { IDD = IDD_LABEL_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

private:
	SDiaryDlg  *ivDiaryDlg;

	SShortcut   *ivShortcut1;
	SShortcut   *ivShortcut2;
	SShortcut   *ivShortcut3;
	SShortcut   *ivShortcut4;
	SShortcut   *ivShortcut5;
	SShortcut   *ivShortcut6;
	SShortcut   *ivShortcut7;
	SShortcut   *ivShortcut8;
	SShortcut   *ivShortcut9;
	SShortcut   *ivShortcut10;
	SShortcut   *ivShortcut11;
	SShortcut   *ivShortcut12;
	SShortcut   *ivShortcut13;
	SShortcut   *ivShortcut14;
	SShortcut   *ivShortcut15;
	SShortcut   *ivShortcut16;
	SShortcut   *ivShortcut17;
	SShortcut   *ivShortcut18;

   // stuff to correctly reposition if offscreen
   bool ivWindowCentered;
   int  ivTop;
   int  ivLeft;

protected:
	DECLARE_MESSAGE_MAP()
public:
    STodoList *ivTodoList0;
    STodoList *ivTodoList1;
    STodoList *ivTodoList2;
    STodoList *ivTodoList3;
    STodoList *ivTodoList4;
    STodoList *ivTodoList5;
    STodoList *ivTodoList6;
    STodoList *ivTodoList7;
	STodoList *GetDefaultTodoList() { return ivTodoList0; };

    virtual BOOL OnInitDialog(void);
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnEnKillfocusEditLbl1();
	afx_msg void OnEnMaxtextEditLbl1();
	afx_msg void OnBnClickedClearall();
	afx_msg void OnEnChangeEditTodo1();
	afx_msg void OnEnChangeEditTodo2();
	afx_msg void OnEnChangeEditTodo3();
	afx_msg void OnEnChangeEditTodo4();
	afx_msg void OnEnChangeEditTodo5();
	afx_msg void OnEnChangeEditTodo6();
	afx_msg void OnEnChangeEditTodo7();
};

#endif