//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Mainly designed and written by Andr Slabber. No Rights Reserved...  Parts by others...
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  File:         SShortcut.h
//  Module:       Diary
//  Author:       Andr Slabber
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  Declaration of Class SShortcut.
//
//////////////////////////////////////////////////////////////////////////////////////////////
#ifndef SSHORTCUT_H_INCLUDED
#define SSHORTCUT_H_INCLUDED

class SLabelDlg;

//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Class SShortcut
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  SShortcut couples the shortcuts in the settings dialog to their counterpart
//                buttons on the main window. 
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Date		Name                  Comments
//	20080921	Andr Slabber         Created
//
//////////////////////////////////////////////////////////////////////////////////////////////
class SShortcut
{
public:
	SShortcut(SDiaryDlg *pDiaryDlg, 
			  SLabelDlg *pLabelDlg, 
			  int pSlotNumber);
	virtual ~SShortcut();

	void ReadFromSettings();
	void WriteToSettings(bool WriteFile);
	void Clear();
	void Revert();
	void Apply();
	void ReadFromDialog();
	void SetOnDialog();
	void SettingsToDialog();
	void DialogToSettings(bool WriteFile);
	void SetButton(int theID);
	void Couple(int pLabelTextControl, int pTimestampControl, int pInsertTextControl);

	CString GetLabelText();
    CString GetInsertText();
    bool NeedsTimestamp();

protected:

private:
	SDiaryDlg *ivDiaryDlg;
	SLabelDlg *ivShortcutDlg;

	int     ivSlotNumber;

	int     ivLabelTextControl;
	int     ivTimestampControl;
	int     ivInsertTextControl;

	CString ivLabelText;
	bool    ivTimestamp;
	CString ivInsertText;

	SSetting *ivLabelSetting;
	SSetting *ivTimeSetting;
	SSetting *ivInsertSetting;
};

#endif // SSHORTCUT_H_INCLUDED