//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Mainly designed and written by Andr Slabber. No Rights Reserved...  Parts by others...
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  File:         Setting.h
//  Module:       Diary
//  Author:       Andr Slabber
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  Declaration of Class Setting.
//
//////////////////////////////////////////////////////////////////////////////////////////////
#ifndef SETTING_H_INCLUDED
#define SETTING_H_INCLUDED

#include "diary.h"

//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Class SSetting
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  SSetting is a single line in the SSettingsFile. It has a name, and a value
//                separated by a colon. I use them to save certain attributes between 
//                sessions. 
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Date		Name                  Comments
//	20080921	Andr Slabber         Created
//
//////////////////////////////////////////////////////////////////////////////////////////////
class SSetting
{
protected:
   CString ivName;
   CString ivValue;

public:
   SSetting(void);
   SSetting(char *pName, char *pValue);
   virtual ~SSetting(void);

   CString GetName(void)              { return ivName;  };
   CString GetValue(void)             { return ivValue; };
   int     GetValueAsNumber(void)     { return atoi(this->ivValue.GetBuffer());  };

   void    SetValue(CString pValue)   { this->ivValue = pValue; };

    static SSetting *ReadSSetting(FILE *pFile);
    void             WriteSSetting(FILE *pFile);

   void Dump(void);
};

#endif
