// This file can be used to store common definitions, like the maximum
// buffer and string lengths used throughout the Diary application.

#ifndef COMMON_H_INCLUDED
#define COMMON_H_INCLUDED

// These are the maximum lengths for strings and buffers. Actually, the 
// buffer length could probably be cut in half (used to be 100K), since 
// the Rich Edit Controls only store 33KB anyway (empirically tested) 

#define MAX_BUFFER    (100000)
#define MAX_STRING      (1000)

// Define these so the old plain C Weekday code has the same notion of booleans as 
// the C++ code. They must be conditional defines, because afx.h defines them also, 
// and I don't want the weekday code to include afx.h, but the Diary code does....

#ifndef FALSE
#define FALSE   (0)
#endif

#ifndef TRUE
#define TRUE  (!FALSE)
#endif

#endif  // COMMON_H_INCLUDED