#ifndef EXCEPTION_H_INCLUDED
#define EXCEPTION_H_INCLUDED

#include <stdio.h>

#include "types.h"
#include "settings.h"

class Exception
{
private:
   char    *ivFile;
   int      ivLine;
   RetCode  ivCode;
   char    *ivText;

public:
   Exception(char *pfile, int pLine, RetCode pCode, char *pMsg = NULL);
   ~Exception(void);

   char    *getFile(void)       { return this->ivFile; };
   int      getLine(void)       { return this->ivLine; };
   RetCode  getCode(void)       { return this->ivCode; };
   char    *getText(void)       { return this->ivText; };

   void     Log(void);

#ifdef TOOLKIT_SELFTEST
   static RetCode selfTest(void);
#endif
};

#endif